org.apache.fop.afp.modca

## Class ActiveEnvironmentGroup

- java.lang.Object
- - org.apache.fop.afp.modca.AbstractAFPObject
  - - org.apache.fop.afp.modca.AbstractStructuredObject
    - - org.apache.fop.afp.modca.AbstractTripletStructuredObject
      - - org.apache.fop.afp.modca.AbstractNamedAFPObject
        - - org.apache.fop.afp.modca.AbstractEnvironmentGroup
          - - org.apache.fop.afp.modca.ActiveEnvironmentGroup

- All Implemented Interfaces:
    Streamable

      public final class ActiveEnvironmentGroup
      extends AbstractEnvironmentGroup

  An Active Environment Group (AEG) is associated with each page, and is contained in the page's begin-end envelope in the data stream. The active environment group contains layout and formatting information that defines the measurement units and size of the page, and may contain resource information. Any objects that are required for page presentation and that are to be treated as resource objects must be mapped with a map structured field in the AEG. The scope of an active environment group is the scope of its containing page or overlay.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `ActiveEnvironmentGroup.FontFullyQualifiedNameTriplet`

    - ### Nested classes/interfaces inherited from class org.apache.fop.afp.modca.AbstractAFPObject

      `AbstractAFPObject.Category, AbstractAFPObject.Type`

  - ### Field Summary

    - ### Fields inherited from class org.apache.fop.afp.modca.AbstractEnvironmentGroup

      `mapDataResources, mapPageOverlays`

    - ### Fields inherited from class org.apache.fop.afp.modca.AbstractNamedAFPObject

      `name`

    - ### Fields inherited from class org.apache.fop.afp.modca.AbstractTripletStructuredObject

      `triplets`

    - ### Fields inherited from class org.apache.fop.afp.modca.AbstractAFPObject

      `LOG, SF_CLASS, SF_HEADER_LENGTH`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ActiveEnvironmentGroup(Factory factory, String name, int width, int height, int widthRes, int heightRes)` Constructor for the ActiveEnvironmentGroup, this takes a name parameter which must be 8 characters long.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addMapPageSegment(String name)` Add map page segment.
    `void` | `createFont(int fontRef, AFPFont font, int size, int orientation)` Method to create a map coded font object
    `PageDescriptor` | `getPageDescriptor()` Accessor method to obtain the PageDescriptor object of the active environment group.
    `PresentationTextDescriptor` | `getPresentationTextDataDescriptor()` Accessor method to obtain the PresentationTextDataDescriptor object of the active environment group.
    `void` | `setObjectAreaPosition(int x, int y, int rotation)` Set the position of the object area
    `static void` | `setupTruetypeMDR(AbstractTripletStructuredObject mdr, boolean res)`
    `void` | `writeContent(OutputStream os)` Helper method to write the contents of the Object.
    `protected void` | `writeEnd(OutputStream os)` Helper method to write the end of the Object.
    `protected void` | `writeStart(OutputStream os)` Helper method to write the start of the Object.

    - ### Methods inherited from class org.apache.fop.afp.modca.AbstractEnvironmentGroup

      `createOverlay, getLastElement`

    - ### Methods inherited from class org.apache.fop.afp.modca.AbstractNamedAFPObject

      `copySF, getName, getNameBytes, getNameLength, setName, toString`

    - ### Methods inherited from class org.apache.fop.afp.modca.AbstractTripletStructuredObject

      `addTriplet, addTriplets, getFullyQualifiedName, getTripletDataLength, getTriplets, hasTriplet, hasTriplets, setComment, setFullyQualifiedName, setFullyQualifiedName, setObjectClassification, writeTriplets`

    - ### Methods inherited from class org.apache.fop.afp.modca.AbstractStructuredObject

      `writeToStream`

    - ### Methods inherited from class org.apache.fop.afp.modca.AbstractAFPObject

      `copySF, truncate, writeChunksToStream, writeObjects`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### ActiveEnvironmentGroup

          public ActiveEnvironmentGroup(Factory factory,
                                        String name,
                                        int width,
                                        int height,
                                        int widthRes,
                                        int heightRes)

      Constructor for the ActiveEnvironmentGroup, this takes a name parameter which must be 8 characters long.
      Parameters:
        `factory` - the object factory
        `name` - the active environment group name
        `width` - the page width
        `height` - the page height
        `widthRes` - the page width resolution
        `heightRes` - the page height resolution

  - ### Method Detail

    - #### setObjectAreaPosition

          public void setObjectAreaPosition(int x,
                                            int y,
                                            int rotation)

      Set the position of the object area
      Parameters:
        `x` - the x offset
        `y` - the y offset
        `rotation` - the rotation

    - #### getPageDescriptor

          public PageDescriptor getPageDescriptor()

      Accessor method to obtain the PageDescriptor object of the active environment group.
      Returns:
        the page descriptor object

    - #### getPresentationTextDataDescriptor

          public PresentationTextDescriptor getPresentationTextDataDescriptor()

      Accessor method to obtain the PresentationTextDataDescriptor object of the active environment group.
      Returns:
        the presentation text descriptor

    - #### writeContent

          public void writeContent(OutputStream os)
                            throws IOException

      Helper method to write the contents of the Object.
      Overrides:
        `writeContent` in class `AbstractEnvironmentGroup`
      Parameters:
        `os` - The stream to write to
      Throws:
        `IOException` - throws an I/O exception if one occurred

    - #### writeStart

          protected void writeStart(OutputStream os)
                             throws IOException

      Helper method to write the start of the Object.
      Overrides:
        `writeStart` in class `AbstractStructuredObject`
      Parameters:
        `os` - The stream to write to
      Throws:
        `IOException` - throws an I/O exception if one occurred

    - #### writeEnd

          protected void writeEnd(OutputStream os)
                           throws IOException

      Helper method to write the end of the Object.
      Overrides:
        `writeEnd` in class `AbstractStructuredObject`
      Parameters:
        `os` - The stream to write to
      Throws:
        `IOException` - an I/O exception if one occurred

    - #### createFont

          public void createFont(int fontRef,
                                 AFPFont font,
                                 int size,
                                 int orientation)

      Method to create a map coded font object
      Parameters:
        `fontRef` - the font number used as the resource identifier
        `font` - the font
        `size` - the point size of the font
        `orientation` - the orientation of the font (e.g. 0, 90, 180, 270)

    - #### setupTruetypeMDR

          public static void setupTruetypeMDR(AbstractTripletStructuredObject mdr,
                                              boolean res)

    - #### addMapPageSegment

          public void addMapPageSegment(String name)

      Add map page segment.
      Parameters:
        `name` - of segment to add

Copyright © 2023 Apache Software Foundation. All rights reserved.